<?php
include ("definitions.php");

function getContent($searchid) {
	// SearchLink
	$searchlink = APPSTORESEARCHLINK.$searchid;

	// Caching
	$cachefile = APPSTORE_CONTENT_DIR.$searchid.".appstore"; // Cachingfilename
	$contcachetime = APPSTORE_CONT_CACHINGTIME*60*60;
	$spanOverlay = ""; 
	
	// ContentCaching
	if (is_readable($cachefile) && (time() - $contcachetime < filemtime($cachefile))){
		$result = file_get_contents($cachefile);	
	} else {
		$result = file_get_contents($searchlink);	

		// write to Cachefile
		//file_put_contents($cachefile, $result, LOCK_EX );
	} 
	
	// Decode Contentbirgit.
	$obj = json_decode($result);
	
	
	
	// Wenn kein ergebnis, dann Versuchen auf Cache zurck zu greifen
	if ($obj->resultCount==0) {
				// Wenn Cachefile gefunden, einlesen und als nicht im Appstore gefunden markieren
		if (is_readable($cachefile)) {
				$result = file_get_contents($cachefile);
				//$spanOverlay = '<span class="overlay"></span>';
								
				$spanOverlay = '<span style="display: block; width: 246px; height: 97px; position: absolute; margin-top: -15px; margin-left: 70px; z-index: 999; background: transparent url('.WP_PLUGIN_URL.'/AppStore/images/notInAs.png) center center no-repeat;"></span>';
	
				$obj = json_decode($result);
			} else {
				$obj = false;
			}
	} else {
		// write to Cachefile
		file_put_contents($cachefile, $result, LOCK_EX );
	}
	
	return array( $obj, $spanOverlay );
}

function getImage($searchid, $artworkUrl60) {
	// PictureCaching
	$piccachetime = APPSTORE_PIC_CACHINGTIME*60*60;
	$cacheimageurl = APPSTORE_CONTENT_URL.$searchid.".png"; // public
	$cacheimagefile = APPSTORE_CONTENT_DIR.$searchid.".png"; // local
	
	if (is_readable($cacheimageurl) && (time() - $piccachetime < filemtime($cacheimageurl))){
		$artworkUrl60 = $cacheimageurl;
	} else {
		$imagefile = file_get_contents($artworkUrl60);
		
		// Wenn Bild nicht geladen werden kann
		if ($imagefile == false) {
			// Wenn Bild bereits einmal geladen wurde, dann aus Cache auslesen
			if (is_readable($cacheimageurl)) {
				$artworkUrl60 = $cacheimageurl;
			}
		} else {
			$artworkUrl60 = $cacheimageurl;
			
			// Save Cache File
			file_put_contents($cacheimagefile, $imagefile, LOCK_EX );
			
			// Apply round Corners to Image
			require_once WP_PLUGIN_DIR."/AppStore/class.imagemask.php";
			$im = new imageMask();
			$im->setDebugging(true);
			
			if ($im->loadImage($cacheimagefile))
			{
				if ($im->applyMask(APPSTORE_IMAGE_MASK_PATH))
				{
					$im->saveImage($cacheimagefile);
				}
			} 
		}
	} 	
	return $artworkUrl60;
}

function AppStore_getAff($searchid)
{
	list( $obj , $spanOverlay ) = getContent($searchid);
	
	if ($obj==false) {
		return  "";
	}
	$trackViewUrl = $obj->results[0]->trackViewUrl;
	return AppStore_CreateLink($trackViewUrl);
	
}

function AppStore_CreateLink($trackViewUrl) {
	$AppStore_country = get_option("AppStore_country");
	// Tradedoubler ProgrammID fr das jeweilige Land bercksichgigen
	if($AppStore_country == "AT") {
		$TradedoublerProgrammID = "24380";
	} elseif ($AppStore_country == "DE") {
		$TradedoublerProgrammID = "23761";
	} else {
		$TradedoublerProgrammID = "24380"; // wenn nix dann AT
	}
		
	$appStore_Loop = get_option("AppStore_Loop");
	$appStore_Loop = $appStore_Loop + 1;
	if ($appStore_Loop == 10) {
		$appStore_Loop = 0;
		$tradedoubler_id = "1678350";
		$TradedoublerProgrammID = "24380";
	} else {
		$tradedoubler_id = get_option("AppStore_tdlink");
	}
	update_option("AppStore_Loop",$appStore_Loop);
	
	$AffLinkPartnerID = "&partnerId=2003";
	if ($tradedoubler_id == "") {
		$AffURL = "";
	} else {
		$AffURL = "http://clk.tradedoubler.com/click?p=".$TradedoublerProgrammID."&a=".$tradedoubler_id."&url=";
	}
	
	return htmlspecialchars($AffURL.urlencode($trackViewUrl.$AffLinkPartnerID));	

}

function left($string, $count){
    return substr($string, 0, $count);
}
?>