<?php
/*
Plugin Name: AppStore Links
Plugin URI: http://www.ste-bi.net
Description: A filter for WordPress that displays AppstoreDetails
Version:1.1.2
Author: Stephan
Author URI: http://www.ste-bi.net

Instructions

Copy the folder that contains this file  unzipped into the wp-content/plugins folder of WordPress, 
then go to Administration > Plugins, it should be in the list. Activtate it 
and avery occurence of the expression [app itemId] (case sensitive) will 
embed an Appstore AppLogo, Name, Price, aso.

Thanks to Manuel, Alexander and Dave who helped me developing this Plugin
*/


if ( !defined('ABSPATH') ) {
	require_once ( '../../../wp-blog-header.php');
}

include ("AppFunctions.php");
include ("definitions.php");
//include ("widget.php");
//wp_enqueue_script('jquery');

function AppStoreLinks_plugin_callback($match)
{
	$searchid = $match[1];
	return AppStoreLinks_getContent($searchid);
}


function AppStoreLinks_getContent($searchid)
{	
	list( $obj , $spanOverlay ) = getContent($searchid);
	
	if ($obj==false) {
		return  "Artikel wurde nicht gefunden";
	}
	
	// Read Content
	$artworkUrl60 = $obj->results[0]->artworkUrl60;
	$trackName = $obj->results[0]->trackName;
	$price = $obj->results[0]->price;
	$AppStore_country = get_option("AppStore_country");
	
	if ($price == 0.00000) {
		$price = "Kostenlos";
	} else {
		if( $AppStore_country == "US") {
			$price .= " USD";
		} else {
			$price .= " EUR";
		}
	}
	
	
	$sellerName = $obj->results[0]->sellerName;
	$sellerUrl = $obj->results[0]->sellerUrl;
	//$trackViewUrl = $obj->results[0]->trackViewUrl;
	$contentAdvisoryRating = $obj->results[0]->contentAdvisoryRating;
	$description = str_replace("\n", "<br />", $obj->results[0]->description);
	$cacheimageurl = getImage($searchid, $artworkUrl60);
	

	$AffLink = WP_PLUGIN_URL."/AppStore/AppStore.php?id=".$searchid;
	
	// Update Benachrichtigung, aber nur wenn nicht aus Appstore entfernt 
	$UpdateTimeSpan = time() - (3*24*60*60); // 3Tage
	$releaseDate = strtotime($obj->results[0]->releaseDate);
		

	if (($releaseDate >= $UpdateTimeSpan) && ($spanOverlay == "")) {
		$spanOverlay = '<span style="display: block; width: 54px; height: 54px; position: absolute; margin-top: 27px; margin-left: 27px; z-index: 999;  background: transparent url('.WP_PLUGIN_URL.'/AppStore/images/update.png) center center no-repeat;"></span>';
	}
	
	
	// Create Output 
	
	// Thickbox einbinden!
//	global $wp_version;
//	  if ($wp_version >= '2.8') {
//		wp_enqueue_script('thickbox28','/wp-includes/js/thickbox/thickbox.js', array('jquery'));
//	  } else {
//		wp_enqueue_script('thickbox');
//	  }
//	  
//	add_thickbox(); // Aus der wp-admin/plugins.php, dort wird Thickbox verwendet.

	
	$output = '<span>'.$spanOverlay;
	$output .= '<a href="'.$AffLink.'" target="_blank">';
	//$output .= '<img class="alignleft" style="margin-right: 5px; margin-left: 5px; margin-top: 5px; margin-bottom: 5px; -moz-border-radius: 10px; -webkit-border-radius: 10px;"';
	$output .= '<img align="left" style="margin-right: 5px; margin-left: 5px; margin-top: 5px; margin-bottom: 5px;" ';
	$output .= 'src="'.$cacheimageurl.'" alt="'.$trackName.' (AppStore Link) " width="57" height="57" /></a> ';
	$output .= '<span  style="font-size: 100%; font-weight:bold; ">'.$trackName.' </span><br /> ';
	$output .= '<span  style="font-size: 80%; ">Hersteller: </span><a href="'.$sellerUrl.'" target="_blank">'.$sellerName.'</a><br /> ';
	$output .= '<span  style="font-size: 80%; ">Freigabe: </span>'.$contentAdvisoryRating.'<br /> ';
	$output .= '<span  style="font-size: 80%; ">Preis: </span>'.$price.' ';
	$output .= '<span  style="font-size: 100%; font-weight:bold; "><a href="'.$AffLink.'" target="_blank">'.APPSTORE_DL_LINKNAME.'</a></span>';
	//$output .= '<a href="http://www.touchtalk.dreamhosters.com/tttest/wp-content/plugins/AppStore/cache/312720263.png&TB_iframe=true&width=640height=580" class="thickbox" title="Test">Test</a>';
	$output .= '</span><br /><br />' ;
	
	
	//$output = '<div style="background-color: transparent; border: 1px solid rgb(128,128,128); width: 70%; ">';
/* 	$output = '<div>';
	$output .= '<a href="'.AFF_LINK.$trackViewUrl.'" target="_blank">';
	//$output .= '<img class="alignleft" style="margin-right: 5px; margin-left: 5px; margin-top: 5px; margin-bottom: 5px; -moz-border-radius: 10px; -webkit-border-radius: 10px;"';
	$output .= '<img class="alignleft" style="margin-right: 5px; margin-left: 5px; margin-top: 5px; margin-bottom: 5px;"';
	$output .= 'title="'.$trackName.' (AppStore Link)" src="'.$cacheimageurl.'" alt="" width="57" height="57" /></a>';
	$output .= '<span  style="font-size: 100%; font-weight:bold; ">'.$trackName.' <a href="#" onclick="jQuery(\'#appdiv'.$searchid.'\').slideToggle(\'slow\'); return false">Beschreibung</a></span><br>';
	$output .= '<span  style="font-size: 80%; ">Hersteller: </span><a href="'.$sellerUrl.'" target="_blank">'.$sellerName.'</a><br>';
	$output .= '<span  style="font-size: 80%; ">Freigabe: </span>'.$contentAdvisoryRating.'<br>';
	$output .= '<span  style="font-size: 80%; ">Preis: </span>'.$price.' ';
	$output .= '<span  style="font-size: 100%; font-weight:bold; "><a href="'.AFF_LINK.$trackViewUrl.'" target="_blank">Download (Aff.Link)</span></a>';
	//$output .= '<div id="appdiv'.$searchid.'">'.$obj->results[0]->description.'</div><br>' ;
	$output .= '<div id="appdiv'.$searchid.'" style="display:none; clear:both; font-size: 100%;">'.$description.'</div><br>' ;
	$output .= '</div><br>' ; */
	return ($output);
}

if ( $_REQUEST['id'] != "" ) {
	header("Location: ".AppStore_getAff($_REQUEST['id']));
 }

if ( $_REQUEST['search'] != "" ) {
	$result = file_get_contents(APPSTORESEARCHLINKNAME.urlencode($_REQUEST['search']));	
	
	// Decode Content
	$obj = json_decode($result);
	
	$count = $obj->resultCount;
	$searchresult = "" ; 
	
	if ($count > 0){
		for ( $i = 0; $i < $count; $i++) {
			$afflink = AppStore_CreateLink($obj->results[$i]->trackViewUrl);
			$imageUrl = $obj->results[$i]->artworkUrl60;
			$trackName = $obj->results[$i]->trackName;
			// Lange Titel krzen
			if (strlen($trackName)>=40) {
				$trackName = left($obj->results[$i]->trackName,37)."..." ;
			}
			//$searchresult .= '<li>';
			$searchresult .= '<a href="'.$afflink.'" target="_blank">';
			$searchresult .= '<img align="left" style="margin-right: 5px; margin-left: 10px; margin-top: 0px; margin-bottom: 10px;" ';
			$searchresult .= 'src="'.$imageUrl.'" alt="'.$trackName.' (AppStore Link) " width="20" height="20" /></a> ';
			$searchresult .= "<a href='".$afflink."'>".$trackName."</a><br /><br />";
			//$searchresult .=  
		}
		//$searchresult .= "</ ol>";
		echo $searchresult;
	}
	
	//touchtalk.dreamhosters.com/tttest/wp-content/plugins/AppStore/AppStore.php?search=tomtom
 } 

 if ( $_REQUEST['searchDetail'] != "" ) {
	$result = file_get_contents(APPSTORESEARCHLINKNAME.urlencode($_REQUEST['searchDetail']));	
	
	// Decode Content
	$obj = json_decode($result);
	
	$count = $obj->resultCount;
	$searchresult = '<center><span style="font-weight:bold;">Deine Suche hat '.$count.' Resultate erzielt</span></center><br />' ; 
	
	if ($count > 0){
		for ( $i = 0; $i < $count; $i++) {
			$afflink = AppStore_CreateLink($obj->results[$i]->trackViewUrl);
			$imageUrl = $obj->results[$i]->artworkUrl60;
			$trackName = $obj->results[$i]->trackName;
			$description = left($obj->results[$i]->description,400)."...";
			$trackName = $obj->results[$i]->trackName;
			$contentAdvisoryRating = $obj->results[$i]->contentAdvisoryRating;
			$sellerName = $obj->results[$i]->sellerName;
			$sellerUrl = $obj->results[$i]->sellerUrl;
			$price = $obj->results[$i]->price;
			
			if ($price == 0.00000) {
					$price = "Kostenlos";
				} else {
					if( $AppStore_country == "US") {
						$price .= " USD";
					} else {
						$price .= " EUR";
					}
				}
			
			$searchresult .= '<table valign="top"><tr><td width=60px>';
			$searchresult .= '<a href="'.$afflink.'" target="_blank">';
			$searchresult .= '<img align="right" style="margin-right: 5px; margin-left: 10px; margin-top: 5px; margin-bottom: 10px; -webkit-border-radius: 10px;" ';
			$searchresult .= 'src="'.$imageUrl.'" alt="'.$trackName.' (AppStore Link) " width="57px" height="57px" border="0px" /></a> </td>';
			//$searchresult .= "<a href='".$afflink."'>".$trackName."</a><br />";
			
			$searchresult .= '<td width=30%><span  style="font-size: 100%; font-weight:bold; ">'.$trackName.' </span><br /> ';
			$searchresult .= '<span  style="font-size: 80%; font-weight:bold; ">Hersteller: </span><a href="'.$sellerUrl.'" target="_blank">'.$sellerName.'</a><br /> ';
			$searchresult .= '<span  style="font-size: 80%; font-weight:bold;">Freigabe: </span>'.$contentAdvisoryRating.'<br /> ';
			$searchresult .= '<span  style="font-size: 80%; font-weight:bold;">Preis: </span>'.$price.' ';
			$searchresult .= '<span  style="font-size: 100%; font-weight:bold; "><a href="'.$afflink.'" target="_blank">Download via iTunes</a></span><br /> </td>';
			$searchresult .= '<td width=60%><span  style="font-size: 80%; font-weight:bold;">Beschreibung:</span><br />'.$description.' </td> ';
			$searchresult .= '</tr></table><br /> ';
		}
	}
	echo $searchresult;
	//touchtalk.dreamhosters.com/tttest/wp-content/plugins/AppStore/AppStore.php?search=tomtom
 } 
 
function AppStoreLinks_plugin($content)
{
	return (preg_replace_callback(APPSTORELINKS_REGEXP, 'AppStoreLinks_plugin_callback', $content));
}

function AppStoreLinks_activate()
{
	// ToDo: Testen ob Jason installiert ist!
	// http://codex.wordpress.org/Function_Reference/register_activation_hook
	add_option("AppStore_country","AT");
	add_option("AppStore_language","de_de");
	add_option("AppStore_picCache","12");
	add_option("AppStore_dataCache","6");
	add_option("AppStore_dlLinkname","Download (Aff.Link)");
	add_option("AppStore_tdlink","1678350");
	add_option("AppStore_Loop",0);
}

function WPWall_ScriptsAction()
{
// $wp_wall_plugin_url = trailingslashit( get_bloginfo('wpurl') ).PLUGINDIR.'/'. dirname( plugin_basename(__FILE__) );
 wp_enqueue_script('thickbox');
 }
 
// Nur wenn der User Adminrechte hat ist
if(is_admin()){
    add_action('admin_menu', 'AppStore_options');
}

/////////////////////
// Optionen einbinden
/////////////////////
function AppStore_options() {
	add_options_page('AppStore', 'AppStore', 8, basename(__FILE__), 'AppStore_options_page');
}

function  AppStore_options_page() {
	$AdminPage = null;
	
	if(isset($_POST['AppStore_save_options']))
		{
			update_option("AppStore_country",attribute_escape($_POST['AppStore_country']));
			update_option("AppStore_language",attribute_escape($_POST['AppStore_language']));
			update_option("AppStore_picCache",attribute_escape($_POST['AppStore_picCache']));
			update_option("AppStore_dataCache",attribute_escape($_POST['AppStore_dataCache']));
			update_option("AppStore_dlLinkname",attribute_escape($_POST['AppStore_dlLinkname']));
			update_option("AppStore_tdlink",attribute_escape($_POST['AppStore_tdlink']));			
		}
	
		$Countries = array(
			"DE" => "Deutschland",
			"AT" => "&Ouml;sterreich"
							);
		asort($Countries);
		// "US" => "USA"
		
		$language = array(
			"de_de" => "Deutsch",
			"en_us" => "Englisch",
			);
		asort($language);	
		
		$AdminPage .= "	
			<form method=\"post\" action=\"".get_settings("siteurl")."/wp-admin/options-general.php?page=AppStore.php\">		
			<div class=\"wrap\">
			<div class=\"icon32\" id=\"icon-options-general\"><br/></div><h2>Einstellungen f&uuml;r das AppStore-Plugin</h2>
			<p>Dieses Plugin l&auml;sst sich ganz einfach mit <code>[app 123456]</code> integrieren.
			</p>
			
			<table>
			<tr>
				<td>iTunes-Store Land:</td>
				<td>
					<select name=\"AppStore_country\" style=\"width:200px;font-weight:bold;\">";
						
						foreach($Countries as $Key => $Country)
						{
							$AdminPage .= "<option value=\"".$Key."\"";
							if(get_option("AppStore_country") == $Key) $AdminPage .= " selected=\"selected\"";
							$AdminPage .= ">".$Country."</option>";
						}
						
					$AdminPage .= "</select>
				</td>
			</tr>
			<tr>
				<td>Sprache:</td>
				<td>
					<select name=\"AppStore_language\" style=\"width:200px;font-weight:bold;\">";
						
						foreach($language as $Key => $language)
						{
							$AdminPage .= "<option value=\"".$Key."\"";
							if(get_option("AppStore_language") == $Key) $AdminPage .= " selected=\"selected\"";
							$AdminPage .= ">".$language."</option>";
						}
						
					$AdminPage .= "</select>
				</td>
			<td>
				</tr>
					<td>Cachingzeit Bilder (in h):</td>
					<td><input type=\"text\" name=\"AppStore_picCache\" value=\"".get_option("AppStore_picCache")."\" style=\"width:200px;font-weight:bold;font-size:9pt;height:20px;padding:1px;border:1px solid #DDDDDD;\"/></td>
				<tr>
			</td>
			<td>
				</tr>
					<td>Cachingzeit Daten (in h):</td>
					<td><input type=\"text\" name=\"AppStore_dataCache\" value=\"".get_option("AppStore_dataCache")."\" style=\"width:200px;font-weight:bold;font-size:9pt;height:20px;padding:1px;border:1px solid #DDDDDD;\"/></td>
				<tr>
			</td>	
			<td>
				</tr>
					<td>Downl.Link Bezeichung:</td>
					<td><input type=\"text\" name=\"AppStore_dlLinkname\" value=\"".get_option("AppStore_dlLinkname")."\" style=\"width:200px;font-weight:bold;font-size:9pt;height:20px;padding:1px;border:1px solid #DDDDDD;\"/></td>
				<tr>
			</td>				
				<td>Tradedoubler ID:</td>
				<td><input type=\"text\" name=\"AppStore_tdlink\" value=\"".get_option("AppStore_tdlink")."\" style=\"width:200px;font-weight:bold;font-size:9pt;height:20px;padding:1px;border:1px solid #DDDDDD;\"/></td>
									<td>Noch kein <a href=\"http://clkde.tradedoubler.com/click?p(745)a(1678350)g(11703467)\" title=\"register to tradedoubler\" target=\"_blank\">Tradedoubler Partner</a>?</td>
				</tr>
				<tr>
					<td colspan=\"2\"><input type=\"submit\" name=\"AppStore_save_options\" value=\"Speichern\" style=\"width:370px;font-weight:bold;font-size:9pt;height:20px;padding:1px;border:1px solid #DDDDDD;\"/></td>
			</tr>
			</table>
			</form>
			
			<h2>Verwendung und Beispiel</h2>
			Die ID der App bekommst du aus dem iTunes-Store. Eimfach den Link der gew&uuml;nschten App kopieren und die Nummer (fast) am Ende suchen: <br /><br />
			
			http://itunes.apple.com/WebObjects/MZStore.woa/wa/viewSoftware?id=284417350&mt=8 <br /><br />
		
			[app 284417350] sollte bei richtiger Konfiguration die Apple Remote App anzeigen. (einfach in einer Seite oder in einem Post einbauen). 
			
			
			<h2>Info</h2>
			<h3>Land</h3>
			Das Land gibt an auf welchen Store die Suche durchgef&uuml;hrt wird. So k&ouml;nnen zB keine Apps angezeigt werden, welche sich nur im US Store befinden aber ein anderer Store eingestellt ist.
			
			<h3>Cachingzeiten</h3>
			Die Cachingzeiten geben an, wie oft die Daten aktualisiert vom Server geladen werden - dies erh&ouml;ht die Performance und sollte eigentlich nicht ge&auml;ndert werden.
			
			<h3>Tradedoubler ID</h3>
			Damit Ihr auch ein wenig Geld damit verdienen k&ouml;nnt ;-)
			
			<h3>Sprache</h3>
			Die Sprache ist derzeit noch eher irrelevant - es wird aber in einer der n&auml;chsten Aktualisierungen ben&ouml;tigt.
					
			Wenn die Sprache oder das iTunes Land umgestellt wird, sollte ggf. auch der Cache gel&ouml;scht werden, da sonst die Preise nicht korrekt sind. 
			
			
			
			<h2>Unterst&uuml;tzung</h2>
			Du wei&szlig;t ja, ein Entwickler ist prinzipiell arm. Ja, ja... traurig aber wahr. Aus diesem Grund steht in jedem 10. Tradedoubler-Link unsere ID um die Entwicklung dieses Plugins und weiterer spannender Projekte zu unterst&uuml;tzen. Deshalb bitten wir dich, den betreffenden Code nicht manuell zu entfernen.
				<form action=\"https://www.paypal.com/cgi-bin/webscr\" method=\"post\">
				<input type=\"hidden\" name=\"cmd\" value=\"_s-xclick\">
				<input type=\"hidden\" name=\"hosted_button_id\" value=\"9401356\">
				<input type=\"image\" src=\"https://www.paypal.com/de_DE/AT/i/btn/btn_donateCC_LG.gif\" border=\"0\" name=\"submit\" alt=\"Jetzt einfach, schnell und sicher online bezahlen  mit PayPal.\">
				<img alt=\"\" border=\"0\" src=\"https://www.paypal.com/de_DE/i/scr/pixel.gif\" width=\"1\" height=\"1\">
				</form>

</form>
		 ";
	echo $AdminPage;
}

	
	
add_filter('the_content', 'AppStoreLinks_plugin');
add_filter('comment_text', 'AppStoreLinks_plugin');
add_action('wp_print_scripts', 'WPWall_ScriptsAction');
register_activation_hook(__FILE__, 'AppStoreLinks_activate' );
?>